local StoneGateV5 = ...

-- Register all stone gate set building parts and their properties
StoneGateV5:dofile("scripts/basicMain.lua")
StoneGateV5:dofile("scripts/basicKeep.lua")
StoneGateV5:dofile("scripts/basicLargeGate.lua")
StoneGateV5:dofile("scripts/basicSmallGate.lua")
StoneGateV5:dofile("scripts/basicSmallSquaredTower.lua")
StoneGateV5:dofile("scripts/basicOctogonalTower.lua")
StoneGateV5:dofile("scripts/hoarding.lua")
StoneGateV5:dofile("scripts/machicolation.lua")
StoneGateV5:dofile("scripts/drawBridge.lua")
StoneGateV5:dofile("scripts/decoration.lua")
StoneGateV5:dofile("scripts/poleFlag.lua")

-- Register the stone gate set monument
StoneGateV5:register({
	DataType = "MONUMENT",
	Id = "STONE_GATE_V5_MONUMENT",
	Name = "STONE_GATE_V5_MONUMENT_NAME",
	Description = "STONE_GATE_V5_MONUMENT_DESC",
	BuildingType = "MONUMENT",
	BuildingPartSetList = {
		{
			Name = "STONE_GATE_V5_MAIN_PARTSETLIST_NAME",
	                BuildingPartList = {
		            "STONE_GATE_V5_MAIN_ROOT_PART",
		            "STONE_GATE_V5_MAIN_ROOTP_PART",
		            "STONE_GATE_V5_MAIN_ROOF_D_PART", -- Closed roof
		            "STONE_GATE_V5_MAIN_ROOF_A_PART", -- Opened roof
		            "STONE_GATE_V5_MAIN_ROOF_B_PART", -- half opened roof 1
		            "STONE_GATE_V5_MAIN_ROOF_C_PART", -- half opened roof 2
		            "STONE_GATE_V5_MAIN_RAMPART_D_PART", -- Closed rampart
		            "STONE_GATE_V5_MAIN_RAMPART_A_PART", -- Opened rampart
		            "STONE_GATE_V5_MAIN_RAMPART_B_PART", -- half opened rampart 1
		            "STONE_GATE_V5_MAIN_RAMPART_C_PART"  -- half opened rampart 2
                        }
                },
		{
			Name = "STONE_GATE_V5_KEEP_PARTSETLIST_NAME",
	                BuildingPartList = {
		            "STONE_GATE_V5_KEEP_ROOT_PART",
		            "STONE_GATE_V5_KEEP_ROOTP_PART",
		            "STONE_GATE_V5_LGATE_ROOT_PART",
		            "STONE_GATE_V5_LGATEB_ROOT_PART",
		            "STONE_GATE_V5_LGATE_ROOTP_PART",
		            "STONE_GATE_V5_KEEP_ROOF_C_PART", -- Closed roof
		            "STONE_GATE_V5_KEEP_ROOF_D_PART", -- 1 side opened
		            "STONE_GATE_V5_KEEP_ROOF_B_PART", -- 2 opposite sides opened
		            "STONE_GATE_V5_KEEP_ROOF_E_PART", -- 2 adjacent sides opened
		            "STONE_GATE_V5_KEEP_ROOF_A_PART", -- 3 sides opened
		            "STONE_GATE_V5_KEEP_ROOF_F_PART", -- all sides opened
		            "STONE_GATE_V5_KEEP_RAMPART_C_PART", -- Closed roof
		            "STONE_GATE_V5_KEEP_RAMPART_D_PART", -- 1 side opened
		            "STONE_GATE_V5_KEEP_RAMPART_B_PART", -- 2 opposite sides opened
		            "STONE_GATE_V5_KEEP_RAMPART_E_PART", -- 2 adjacent sides opened
		            "STONE_GATE_V5_KEEP_RAMPART_A_PART", -- 3 sides opened
		            "STONE_GATE_V5_KEEP_RAMPART_F_PART"  -- all sides opened
                        }
                },
		{
			Name = "STONE_GATE_V5_HOARDING_PARTSETLIST_NAME",
	                BuildingPartList = {
		            "STONE_GATE_V5_HOARDING_S2L0R0_PART",
		            "STONE_GATE_V5_HOARDING_S2L0R1_PART",
		            "STONE_GATE_V5_HOARDING_S2L1R0_PART",
		            "STONE_GATE_V5_HOARDING_S2L1R1_PART",
		            "STONE_GATE_V5_EXTENSION_S2L0R0_PART",
		            "STONE_GATE_V5_HOARDING_S3L0R0_PART",
		            "STONE_GATE_V5_HOARDING_S3L0R1_PART",
		            "STONE_GATE_V5_HOARDING_S3L1R0_PART",
		            "STONE_GATE_V5_HOARDING_S3L1R1_PART",
		            "STONE_GATE_V5_EXTENSION_S3L0R0_PART"
                        }
                },
		{
			Name = "STONE_GATE_V5_MACHICOLATION_PARTSETLIST_NAME",
	                BuildingPartList = {
		            "STONE_GATE_V5_MACHICOLATION_KEEP_C_PART",
		            "STONE_GATE_V5_MACHICOLATION_KEEP_C_P_PART",
		            "STONE_GATE_V5_MACHICOLATION_CRENATION34_PART",
		            "STONE_GATE_V5_MACHICOLATION_CRENATION40R_PART",
		            "STONE_GATE_V5_MACHICOLATION_CRENATION40L_PART",
		            "STONE_GATE_V5_MACHICOLATION_CRENATION50_PART",
		            "STONE_GATE_V5_MACHICOLATION_KEEP_ROOF_C_PART",
		            "STONE_GATE_V5_MACHICOLATION_MAIN_D_PART",
		            "STONE_GATE_V5_MACHICOLATION_MAIN_D_P_PART",
		            "STONE_GATE_V5_MACHICOLATION_CRENATION54_PART",
		            "STONE_GATE_V5_MACHICOLATION_CRENATION60R_PART",
		            "STONE_GATE_V5_MACHICOLATION_CRENATION60L_PART",
		            "STONE_GATE_V5_MACHICOLATION_CRENATION70_PART",
		            "STONE_GATE_V5_MACHICOLATION_MAIN_ROOF_D_PART"
		        }
                },
		{
			Name = "STONE_GATE_V5_SST_PARTSETLIST_NAME",
	                BuildingPartList = {
		            "STONE_GATE_V5_SST_ROOT_PART",
		            "STONE_GATE_V5_SST_ROOTP_PART",
		            "STONE_GATE_V5_SST_ROOF_A_PART", -- Closed roof
		            "STONE_GATE_V5_SST_ROOF_B_PART",  -- 1 side opened roof
		            "STONE_GATE_V5_SST_RAMPART_A_PART",  -- Close rampart
		            "STONE_GATE_V5_SST_RAMPART_B_PART",   -- 1 side opened rampart
		            "STONE_GATE_V5_SST_RAMPART_C_PART",   -- 1 side closed rampart
		            "STONE_GATE_V5_HOARDING_S1_A_PART",
		            "STONE_GATE_V5_HOARDING_S1_B_PART",
		            "STONE_GATE_V5_MACHICOLATION_SST_RAMPART_A_PART",
		            "STONE_GATE_V5_MACHICOLATION_SST_RAMPART_B_PART",
		            "STONE_GATE_V5_MACHICOLATION_SST_RAMPART_AP_PART",
		            "STONE_GATE_V5_MACHICOLATION_SST_RAMPART_BP_PART",
		            "STONE_GATE_V5_MACHICOLATION_SST_ROOF_A_PART", -- Closed roof
		            "STONE_GATE_V5_MACHICOLATION_SST_ROOF_B_PART",  -- 1 side opened roof
		            "STONE_GATE_V5_SST_STAIR_A_PART",   -- stairs with stone floor
		            "STONE_GATE_V5_SST_STAIR_B_PART",   -- stairs with wooden floor
		            "STONE_GATE_V5_SST_STAIR_C_PART",   -- stairs foundation with stone floor
		            "STONE_GATE_V5_SST_STAIR_D_PART",   -- stairs foundation with wooden floor
         	            "STONE_GATE_V5_SST_RAMPART_D_PART",   -- 1 side for stairs
		            "STONE_GATE_V5_SST_RAMPART_E_PART"   -- 1 side for stairs
                        }
                },
		{
			Name = "STONE_GATE_V5_SGATE_PARTSETLIST_NAME",
	                BuildingPartList = {
		            "STONE_GATE_V5_SGATE_ROOT_PART",
		            "STONE_GATE_V5_SGATE_EXT_ROOT_PART",
		            "STONE_GATE_V5_SGATE_ROOT_P_PART",
		            "STONE_GATE_V5_SGATE_EXT_ROOT_P_PART",
		            "STONE_GATE_V5_SGATE_RAMPART_A_PART",
		            "STONE_GATE_V5_SGATE_RAMPART_CLOSING_L_PART",
		            "STONE_GATE_V5_SGATE_RAMPART_CLOSING_R_PART",
		            "STONE_GATE_V5_SGATE_HOARDING_A_PART",
		            "STONE_GATE_V5_SGATE_MACHICOLATION_A_PART",
		            "STONE_GATE_V5_SGATE_MACHICOLATION_B_PART",
		            "STONE_GATE_V5_SGATE_MACHICOLATION_CLOSING_L_PART",
		            "STONE_GATE_V5_SGATE_MACHICOLATION_CLOSING_R_PART",
		            "STONE_GATE_V5_SGATE_MACHICOLATION_WOODEN_ROOF_A_PART",
		            "STONE_GATE_V5_SGATE_MACHICOLATION_STONE_ROOF_A_PART"
                        }
                },
		{
			Name = "STONE_GATE_V5_OTOWER_PARTSETLIST_NAME",
	                BuildingPartList = {
		            "STONE_GATE_V5_OTOWER_ROOT_PART",
		            "STONE_GATE_V5_OTOWER_ROOTB_PART",
		            "STONE_GATE_V5_OTOWER_ROOF_PART",
		            "STONE_GATE_V5_OTOWER_RAMPART_PART", -- all sides
		            "STONE_GATE_V5_OTOWER_RAMPART_B_PART", -- one side
		            "STONE_GATE_V5_OTOWER_RAMPART_C_PART", -- one side open
		            "STONE_GATE_V5_OTOWER_HOARDING_PART",
		            "STONE_GATE_V5_OTOWER_HOARDING_EXT_PART",
		            "STONE_GATE_V5_OTOWER_MACHICOLATION_PART",
		            "STONE_GATE_V5_OTOWER_MACHICOLATION_B_PART",
		            "STONE_GATE_V5_OTOWER_MACHICOLATION_ROOF_PART"
                        }
                },
		{
			Name = "STONE_GATE_V5_ENTRANCE_PARTSETLIST_NAME",
	                BuildingPartList = {
 		            "STONE_GATE_V5_ENTRANCE_DOOR_A_PART",
  		            "STONE_GATE_V5_ENTRANCE_DOOR_B_PART"
                       }
                },
		{
			Name = "STONE_GATE_V5_BRIDGE_PARTSETLIST_NAME",
	                BuildingPartList = {
		            "STONE_GATE_V5_DRAW_BRIDGE_A_CORE_PART",
		            "STONE_GATE_V5_DRAW_BRIDGE_B_CORE_PART",
		            "STONE_GATE_V5_DRAW_BRIDGE_HARROW_PART"
                        }
                },
		{
			Name = "STONE_GATE_V5_DECORATION_PARTSETLIST_NAME",
	                BuildingPartList = {
		            "STONE_GATE_V5_DECORATION_SFENETRE_PART",
		            "STONE_GATE_V5_DECORATION_LFENETRE_PART",
		            "STONE_GATE_V5_DECORATION_PFENETRE_PART",
		            "STONE_GATE_V5_DECORATION_ARROWSLIT_PART",
		            "STONE_GATE_V5_DECORATION_BALCONY_PART",
		            "STONE_GATE_V5_DECORATION_DOOR_A_PART",
		            "STONE_GATE_V5_DECORATION_DOOR_B_PART",
		            "STONE_GATE_V5_DECORATION_DOOR_MA_PART",
		            "STONE_GATE_V5_DECORATION_DOOR_MB_PART",
		            "STONE_GATE_V5_DECORATION_BUTTRESS_PART",
		            "STONE_GATE_V5_DECORATION_CHIMNEY_BASE_PART",
		            "STONE_GATE_V5_DECORATION_CHIMNEY_PART",
		            "STONE_GATE_V5_DECORATION_LUCARNE_PART",
		            "STONE_GATE_V5_DECORATION_TURRET_PART",
		            "STONE_GATE_V5_DECORATION_STONE_ROUND_WINDOW_PART",
		            "STONE_GATE_V5_POLE_FLAG_RED_ROOT_PART",
		            "STONE_GATE_V5_POLE_FLAG_BLUE_ROOT_PART",
		            "STONE_GATE_V5_POLE_FLAG_GREEN_ROOT_PART",
		            "STONE_GATE_V5_POLE_FLAG_PURPLE_ROOT_PART",
		            "STONE_GATE_V5_POLE_FLAG_ORANGE_ROOT_PART",
		            "STONE_GATE_V5_POLE_FLAG_TURQUOISE_ROOT_PART"
                        }
                }                  
	},
	RequiredPartList = {
		-- Necessarily a list of 'MONUMENT_REQUIRED_PART_PAIR', no need to specify the DataType of each element of the list
		{ Category = "CORE", Quantity = 1 }
	},
        IsEditable = true
})